using CD67.FicheCollege.Entity;
using CD67.FicheCollege.Factory;
using CD67.FicheCollege.MVC.Models;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;

namespace CD67.FicheCollege.MVC.Controllers
{
    public class ActionsEduActeursController : Controller
    {
        private Entities db = new Entities();

        // GET: ActionsEdu/Details/5
        public ActionResult Details(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            ActionEduActeurFactory fact = new ActionEduActeurFactory(db);
            Entity.ActionEduActeur actionEduActeur = fact.getById(id);
            if (actionEduActeur == null)
            {
                return HttpNotFound();
            }
            ActionEduActeurViewModel model = new ActionEduActeurViewModel(actionEduActeur, db);

            return View(model);
        }

        // GET: ActionEduCollege/Create
        public ActionResult Create(int? actionEdu_id)
        {
            if (actionEdu_id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            ActionEduActeur actionEduActeur = new ActionEduActeur();
            actionEduActeur.ActionEduId = actionEdu_id.Value;
            ActionEduFactory fact = new ActionEduFactory(db);
            actionEduActeur.ActionEdu = fact.getById(actionEdu_id);

            ActionEduActeurViewModel model = new ActionEduActeurViewModel(actionEduActeur, db, ModeAcces.Creation);
            return View("Edit", model);
        }

        // POST: ActionEduAxe/Create
        // Afin de déjouer les attaques par sur-validation, activez les propriétés spécifiques que vous voulez lier. Pour 
        // plus de détails, voir  http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create(ActionEduActeur actionEduActeur)
        {
            if (ModelState.IsValid)
            {
                ActionEduActeurFactory fact = new ActionEduActeurFactory(db);
                fact.add(ref actionEduActeur);
                return RedirectToAction("Details", "ActionsEdu", new { Id = actionEduActeur.ActionEduId });
            }

            ActionEduActeurViewModel model = new ActionEduActeurViewModel(actionEduActeur, db, ModeAcces.Creation);
            return View("Edit", model);
        }

        // GET: ActionEduAxe/Edit/5
        public ActionResult Edit(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            ActionEduActeurFactory fact = new ActionEduActeurFactory(db);
            ActionEduActeur actionEduActeur = fact.getById(id.Value);
            if (actionEduActeur == null)
            {
                return HttpNotFound();
            }
            ActionEduActeurViewModel model = new ActionEduActeurViewModel(actionEduActeur, db, ModeAcces.Modification);
            return View(model);
        }

        // POST: ActionEduAxe/Edit/5
        // Afin de déjouer les attaques par sur-validation, activez les propriétés spécifiques que vous voulez lier. Pour 
        // plus de détails, voir  http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit(ActionEduActeur actionEduActeur)
        {
            if (ModelState.IsValid)
            {
                ActionEduActeurFactory fact = new ActionEduActeurFactory(db);
                fact.update(ref actionEduActeur);
                return RedirectToAction("Details", new { id = actionEduActeur.Id });
            }
            ActionEduActeurViewModel model = new ActionEduActeurViewModel(actionEduActeur, db, ModeAcces.Modification);
            return View(model);
        }

        // GET: ActionEduAxe/Delete/5
        public ActionResult Delete(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            ActionEduActeurFactory fact = new ActionEduActeurFactory(db);
            ActionEduActeur actionEduActeur = fact.getById(id.Value);
            if (actionEduActeur == null)
            {
                return HttpNotFound();
            }
            ActionEduActeurViewModel model = new ActionEduActeurViewModel(actionEduActeur, db);
            return View(model);
        }

        // POST: ActionEduAxe/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public ActionResult DeleteConfirmed(int id)
        {
            ActionEduActeurFactory fact = new ActionEduActeurFactory(db);
            ActionEduActeur actionEduActeur = fact.getById(id);
            fact.delete(ref actionEduActeur);
            return RedirectToAction("Details", "ActionsEdu", new { id = actionEduActeur.ActionEduId });
        }

    }
}